#!/bin/sh

argVENDORID=$1
argDEVICEID=$2
argSUBVENID=$3
argSUBDEVID=$4

for PCIDEVDIR in /sys/bus/pci/devices/*
do
	VENDORID=$(<${PCIDEVDIR}/vendor)
	VENDORID=${VENDORID#0x}
	DEVICEID=$(<${PCIDEVDIR}/device)
	DEVICEID=${DEVICEID#0x}
	SUBVENID=$(<${PCIDEVDIR}/subsystem_vendor)
	SUBVENID=${SUBVENID#0x}
	SUBDEVID=$(<${PCIDEVDIR}/subsystem_device)
	SUBDEVID=${SUBDEVID#0x}
	
	if [ -z "${argVENDORID}" ]; then
		echo "${PCIDEVDIR##*/} ${VENDORID}:${DEVICEID} (${SUBVENID}:${SUBDEVID})"
		continue
	fi
	
	if [ "${VENDORID}" == "${argVENDORID}" -a "${DEVICEID}" == "${argDEVICEID}" ]; then
		if [ -z "${argSUBVENID}" ]; then
			exit 0
		fi
		if [ "${SUBVENID}" == "${argSUBVENID}" -a "${SUBDEVID}" == "${argSUBDEVID}" ]; then
			exit 0
		fi
	fi
done

exit 1
